﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace SmartClient1
{
	/// <summary>
	/// COM 에 노출할 이벤트 메서드
	/// </summary>
	[Guid("F9F21A39-FC35-4503-95E1-FBB13E749C3E")]
	[InterfaceType( ComInterfaceType.InterfaceIsIDispatch )]
	public interface IUmcClick
	{
		[DispId(0x60020000)]
		void UmcClick();

		[DispId(0x60030000)]
		void UmcParamClick( string param );
	}

	[ClassInterface( ClassInterfaceType.AutoDual)]
	[ComSourceInterfaces(typeof(IUmcClick))]
	public partial class UserControl1 : UserControl
	{
		// 인자없는 이벤트
		public delegate void UmcClickHandler();
		public event UmcClickHandler UmcClick;

		// 문자열 인자를 넘길 이벤트
		public delegate void UmcParamClickHandler( string param );
		public event UmcParamClickHandler UmcParamClick;

		public UserControl1()
		{
			InitializeComponent();

			button1.Click += new EventHandler(delegate(object sender, EventArgs e) { 
					MessageBox.Show("UI 에서 연결한 이벤트"); 
				} );
		}

		/// <summary>
		/// Raise Event
		/// </summary>
		private void OnUmcClick()
		{
			if( UmcClick != null )
			    Invoke( UmcClick, null );
		}

		/// <summary>
		/// Raise Event
		/// </summary>
		private void OnParamUmcClick()
		{
			// 인자값을 넘긴다.
			if( UmcParamClick != null )
			    Invoke( UmcParamClick, "스마트클라이언트가 전달한 메세지");
		}

		private void button1_Click(object sender, EventArgs e)
		{
			OnUmcClick();
		}

		private void button2_Click(object sender, EventArgs e)
		{
			OnParamUmcClick();
		}
	}
}
